<?php
/**
 * @category    Payment
 * @author      Global Payments Europe s.r.o. (emailgpwebpay@gpe.cz)
 */

defined('_JEXEC') or die();

require_once (__DIR__ . '/../payments/pm_gpwebpay/Muzo/gpmuzo.php');

class JshoppingControllerGpwebpay extends JshoppingControllerBase{

    function __construct($config = array()){
        parent::__construct($config);
        JPluginHelper::importPlugin('jshoppingcheckout');
        JPluginHelper::importPlugin('jshoppingorder');
        JDispatcher::getInstance()->trigger('onConstructJshoppingControllerCheckout', array(&$this));
    }

    function checkResponse(){
        $return = JURI::root()."index.php?option=com_jshopping&controller=checkout&task=step7&act=return&js_paymentclass=pm_gpwebpay";
        $cancel_return = JURI::root()."index.php?option=com_jshopping&controller=checkout&task=step7&act=cancel&js_paymentclass=pm_gpwebpay";
    
        $prcode = isset($_GET['PRCODE']) ? $_GET['PRCODE'] : null;
        $srcode = isset($_GET['SRCODE']) ? $_GET['SRCODE'] : null;
        $resultValidation = self::isResponseValid($_GET);
        
        $url = $cancel_return;
        if($resultValidation && $prcode == '0' && $srcode == '0')
            $url = $return;
        else if($resultValidation && $prcode == '50' && $srcode == '0')
            $url = $cancel_return;
        else
            $url = $cancel_return;
        
        Header("Location: ".$url."");
        die;
    }
    
    function isResponseValid($response)
    {
        $rootPathToJshopping = __DIR__ . '/..';
        $validationResult = false;
        
        $merchantOrderNumber = $response['MERORDERNUM'];
        $order = JSFactory::getTable('order', 'jshop');
        $order_id = $merchantOrderNumber;
        $order->load($order_id);
        $pm_method = JSFactory::getTable('paymentMethod', 'jshop');
        $pm_method->load($order->payment_method_id);
        $pmconfigs = $pm_method->getConfigs();
        
        $rootPath = dirname(__DIR__);
        $certPath = $rootPathToJshopping . "/payments/pm_gpwebpay/Certs/";
        
        $orderNumber = $response['ORDERNUMBER'];
    
        $publicKeyFilename = $pmconfigs['public_key_file'];
        $muzoPublicKeyFile = $certPath . $publicKeyFilename;
        $merchantNumber = $pmconfigs['merchant_number'];
        $md = $response['MD']; 
        $prCode = $response['PRCODE']; 
        $srCode = $response['SRCODE'];
        $resultText = $response['RESULTTEXT'];
        $validationResult = GpMuzo_ReceiveReply(// funkce zpracuje a overi zpetne presmerovani z Muzo
            $muzoPublicKeyFile, // soubor s verejnym klicem Muzo
            $orderNumber, // cislo objednavky
            $merchantOrderNumber, // identifikace objednavky pro obchodnika
            $md, // data obchodnika, pouze ASCII
            $prCode, // primarni kod
            $srCode, // sekundarni kod
            $resultText, // slovni popis chyby
            $merchantNumber);
    
        return $validationResult;
    }
       
}